<?php
    
    namespace frontend\microdata;
    
    use frontend\microdata\Microdata;
    
    class MicrodataFabric extends Microdata
    {
        public static function createJsonFromProduct($product)
        {
            return ( $product == null ) ? new ProductMicrodata(
                array_merge([ 'url' => 123 ], self::getDefaultSettings())
            ) : new ProductMicrodata(array_merge($product, [ 'url' => 123 ], self::getDefaultSettings()));
        }
        public static function createJsonFromArticle($article = null)
        {
            
            return ( $article == null ) ? new ArticleMicrodata(
                array_merge([ 'url' => 123 ], self::getDefaultSettings())
            ) : new ArticleMicrodata(array_merge($article, [ 'url' => 123 ], self::getDefaultSettings()));
        }
        public static function createJsonFromOrganization($article = null)
        {
            
            return ( $article == null ) ? new OrganizationMicrodata(
                array_merge(self::getDefaultSettings())
            ) : #die(var_dump(self::getDefaultSettings()));
                #die(var_dump(array_merge($article,self::getDefaultSettings())));
                new OrganizationMicrodata(
                    array_merge(
                        $article,
                        self::getDefaultSettings()
                    )
                );
        }
        
        protected static function getDefaultSettings()
        {
            return [
                'context' => "http://schema.org",
            
            ];
            
        }
        
    }